import java.util.* ;
public class Map2
{ public static void main (String args[])
  { TreeMap m = new TreeMap() ;
    m.put ("c", "10") ; m.put ("f", "20") ; m.put ("k", "30") ;
    m.put ("x", "40") ; m.put ("p", "50") ; m.put ("g", "60") ;
    System.out.println ("map initial :                        " + m) ;

    // retrouver la valeur associee a la cle "f"
    String ch = (String)m.get("f") ;
    System.out.println ("valeur associee a f :                " + ch) ;

    // ensemble des valeurs
    Collection valeurs = m.values () ;  // attention, ici Collection, pas Set
    System.out.println ("liste des valeurs initiales :        " + valeurs) ;
    valeurs.remove ("30") ; // on supprime la valeur "30" par la vue associee
    System.out.println ("liste des valeurs apres sup :        " + valeurs) ;

    // ensemble des cles
    Set cles = m.keySet () ;
    System.out.println ("liste des cles initiales :           " + cles) ;
    cles.remove ("p") ;     // on supprime la cle "p" par la vue associee
    System.out.println ("liste des cles apres sup :           " + cles) ;

    // modification de la valeur associee a la cl x
    String old = (String)m.put("x", "25") ;
    if (old != null)
    System.out.println ("valeur associee a x avant modif :    " + old) ;
    System.out.println ("map apres modif de x :               " + m) ;
    System.out.println ("liste des valeurs apres modif de x : " + valeurs) ;

    // On parcoure les entree (Map.Entry) du map jusqu'a trouver la valeur 20
    // et on supprime l'element correspondant (suppose exister)
    Set entrees = m.entrySet () ;
    Iterator iter = entrees.iterator() ;
    while (iter.hasNext())
    { Map.Entry entree = (Map.Entry)iter.next() ;
      String valeur = (String)entree.getValue() ;
      if (valeur.equals ("20"))
        { System.out.println ("valeur 20 " + "trouvee en cle "
                              + (String)entree.getKey()) ;
          iter.remove() ; // suppression sur la vue associee
          break ;
        }
    }
    System.out.println ("map apres sup element suivant 20 :   " + m) ;

    // on supprime l'element de cle "f"
    m.remove ("f") ;
    System.out.println ("map apres suppression f :            " + m) ;
    System.out.println ("liste des cles apres suppression f : " + cles) ;
    System.out.println ("liste des valeurs apres supp de f  : " + valeurs) ;
  }
}

/*
map initial :                        {c=10, f=20, g=60, k=30, p=50, x=40}
valeur associee a f :                20
liste des valeurs initiales :        [10, 20, 60, 30, 50, 40]
liste des valeurs apres sup :        [10, 20, 60, 50, 40]
liste des cles initiales :           [c, f, g, p, x]
liste des cles apres sup :           [c, f, g, x]
valeur associee a x avant modif :    40
map apres modif de x :               {c=10, f=20, g=60, x=25}
liste des valeurs apres modif de x : [10, 20, 60, 25]
valeur 20 trouvee en cle f
map apres sup element suivant 20 :   {c=10, g=60, x=25}
map apres suppression f :            {c=10, g=60, x=25}
liste des cles apres suppression f : [c, g, x]
liste des valeurs apres supp de f  : [10, 60, 25]
*/



